﻿using DTO;
using EntityFrameworkLOL.DBContexts;
using EntityFrameworkLOL.Entities;
using Model;

namespace APILOL.Mapper
{
    public static class SkillMapper
    {
        public static SkillEntity ToEntity(this Skill item, ChampionEntity champion, SQLiteContext context)
        {
            var skillEntity = context.Skill.Find(item.Name);
            if (skillEntity == null)
            {
                return new()
                {
                    Name = item.Name,
                    Description = item.Description,
                    Type = item.Type,
                    Champions = new List<ChampionEntity>() { champion }
                };
            }
            skillEntity!.Champions?.Add(champion);
            return skillEntity;
        }


        public static Skill ToModel(this SkillEntity entity)
        => new(entity.Name, entity.Type, entity.Description);
    }
}
